PF-build.sh 62 KB

12345678910111213141516171819202122232425262728293031323334353637383940414243444546474849505152535455565758596061626364656667686970717273747576777879808182838485868788899091929394959697989910010110210310410510610710810911011111211311411511611711811912012112212312412512612712812913013113213313413513613713813914014114214314414514614714814915015115215315415515615715815916016116216316416516616716816917017117217317417517617717817918018118218318418518618718818919019119219319419519619719819920020120220320420520620720820921021121221321421521621721821922022122222322422522622722822923023123223323423523623723823924024124224324424524624724824925025125225325425525625725825926026126226326426526626726826927027127227327427527627727827928028128228328428528628728828929029129229329429529629729829930030130230330430530630730830931031131231331431531631731831932032132232332432532632732832933033133233333433533633733833934034134234334434534634734834935035135235335435535635735835936036136236336436536636736836937037137237337437537637737837938038138238338438538638738838939039139239339439539639739839940040140240340440540640740840941041141241341441541641741841942042142242342442542642742842943043143243343443543643743843944044144244344444544644744844945045145245345445545645745845946046146246346446546646746846947047147247347447547647747847948048148248348448548648748848949049149249349449549649749849950050150250350450550650750850951051151251351451551651751851952052152252352452552652752852953053153253353453553653753853954054154254354454554654754854955055155255355455555655755855956056156256356456556656756856957057157257357457557657757857958058158258358458558658758858959059159259359459559659759859960060160260360460560660760860961061161261361461561661761861962062162262362462562662762862963063163263363463563663763863964064164264364464564664764864965065165265365465565665765865966066166266366466566666766866967067167267367467567667767867968068168268368468568668768868969069169269369469569669769869970070170270370470570670770870971071171271371471571671771871972072172272372472572672772872973073173273373473573673773873974074174274374474574674774874975075175275375475575675775875976076176276376476576676776876977077177277377477577677777877978078178278378478578678778878979079179279379479579679779879980080180280380480580680780880981081181281381481581681781881982082182282382482582682782882983083183283383483583683783883984084184284384484584684784884985085185285385485585685785885986086186286386486586686786886987087187287387487587687787887988088188288388488588688788888989089189289389489589689789889990090190290390490590690790890991091191291391491591691791891992092192292392492592692792892993093193293393493593693793893994094194294394494594694794894995095195295395495595695795895996096196296396496596696796896997097197297397497597697797897998098198298398498598698798898999099199299399499599699799899910001001100210031004100510061007100810091010101110121013101410151016101710181019102010211022102310241025102610271028102910301031103210331034103510361037103810391040104110421043104410451046104710481049105010511052105310541055105610571058105910601061106210631064106510661067106810691070107110721073107410751076107710781079108010811082108310841085108610871088108910901091109210931094109510961097109810991100110111021103110411051106110711081109111011111112111311141115111611171118111911201121112211231124112511261127112811291130113111321133113411351136113711381139114011411142114311441145114611471148114911501151115211531154115511561157115811591160116111621163116411651166116711681169117011711172117311741175117611771178117911801181118211831184118511861187118811891190119111921193119411951196119711981199120012011202120312041205120612071208120912101211121212131214121512161217121812191220122112221223122412251226122712281229123012311232123312341235123612371238
  1. #!/bin/bash
  2. # This bash script is used to compile automatically the Prusa firmware with a dedicated build environment and settings
  3. #
  4. # Supported OS: Windows 10, Linux64 bit
  5. # Beta OS: Linux32 bit
  6. #
  7. # Linux:
  8. #
  9. # Windows:
  10. # To execute this script you gonna need few things on your Windows machine
  11. #
  12. # Linux Subsystem Ubuntu
  13. # 1. Follow these instructions
  14. # 2. Open Ubuntu bash and get latest updates with 'apt-get update'
  15. # 3. Install zip with 'apt-get install zip'
  16. # 4. Install python3 with 'apt-get install python3'
  17. # 5. Add command 'ln -sf /usr/bin/python3.5 /usr/bin/python' to link python3 to python.
  18. # Do not install 'python' as python 2.x has end of life see https://pythonclock.org/
  19. # 6. Add at top of ~/.bashrc following lines by using 'sudo nano ~/.bashrc'
  20. #
  21. # export OS="Linux"
  22. # export JAVA_TOOL_OPTIONS="-Djava.net.preferIPv4Stack=true"
  23. # export GPG_TTY=$(tty)
  24. #
  25. # and confirm them. Restart Ubuntu bash
  26. #
  27. # Or GIT-BASH
  28. # 1. Download and install the correct (64bit or 32bit) Git version https://git-scm.com/download/win
  29. # 2. Also follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058
  30. # 3. Download and install 7z-zip from its official website.
  31. # By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case.
  32. # 4. Run git Bash under Administrator privilege and navigate to the directory /c/Program Files/Git/mingw64/bin,
  33. # you can run the command ln -s /c/Program Files/7-Zip/7z.exe zip.exe
  34. #
  35. # Useful things to edit and compare your custom Firmware
  36. # 1. Download and install current and correct (64bit or 32bit) Notepad++ version https://notepad-plus-plus.org/download
  37. # 2. Another great tool to compare your custom mod and stock firmware is WinMerge http://winmerge.org/downloads/?lang=en
  38. #
  39. # Example for MK3: open git bash and change to your Firmware directory
  40. # <username>@<machine name> MINGW64 /<drive>/path
  41. # bash build.sh 1_75mm_MK3-EINSy10a-E3Dv6full
  42. #
  43. # Example for MK25: open git bash and change to your directory
  44. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware/MK3
  45. # bash build.sh 1_75mm_MK25-RAMBo13a-E3Dv6full
  46. #
  47. # The compiled hex files can be found in the folder above like from the example
  48. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware
  49. # FW351-Build1778-1_75mm_MK25-RAMBo13a-E3Dv6full.hex
  50. #
  51. # Why make Arduino IDE portable?
  52. # To have a distinguished Prusa Firmware build environment I decided to use Arduino IDE in portable mode.
  53. # - Changes made to other Arduino instances do not change anything in this build environment.
  54. # By default Arduino IDE uses "users" and shared library folders which is useful as soon you update the Software.
  55. # But in this case we need a stable and defined build environment, so keep it separated it kind of important.
  56. # Some may argue that this is only used by a script, BUT as soon someone accidentally or on purpose starts Arduino IDE
  57. # it will use the default Arduino IDE folders and so can corrupt the build environment.
  58. #
  59. # Version: 1.2.0-Build_54
  60. # Change log:
  61. # 12 Jan 2019, 3d-gussner, Fixed "compiler.c.elf.flags=-w -Os -Wl,-u,vfprintf -lprintf_flt -lm -Wl,--gc-sections" in 'platform.txt'
  62. # 16 Jan 2019, 3d-gussner, Build_2, Added development check to modify 'Configuration.h' to prevent unwanted LCD messages that Firmware is unknown
  63. # 17 Jan 2019, 3d-gussner, Build_3, Check for OS Windows or Linux and use the right build environment
  64. # 10 Feb 2019, ropaha, Pull Request, Select variant from list while using build.sh
  65. # 10 Feb 2019, ropaha, change FW_DEV_VERSION automatically depending on FW_VERSION RC/BETA/ALPHA
  66. # 10 Feb 2019, 3d-gussner, 1st tests with English only
  67. # 10 Feb 2019, ropaha, added compiling of all variants and English only
  68. # 10 Feb 2019, 3d-gussner, Set OUTPUT_FOLDER for hex files
  69. # 11 Feb 2019, 3d-gussner/ropaha, Minor changes and fixes
  70. # 11 Feb 2019, 3d-gussner, Ready for RC
  71. # 12 Feb 2019, 3d-gussner, Check if wget and zip are installed. Thanks to Bernd to point it out
  72. # 12 Feb 2019, 3d-gussner, Changed OS check to OSTYPE as it is not supported on Ubuntu
  73. # Also added different BUILD_ENV folders depending on OS used so Windows
  74. # Users can use git-bash AND Windows Linux Subsystems at the same time
  75. # Cleanup compiler flags is only depends on OS version.
  76. # 12 Feb 2019, 3d-gussner, Added additional OSTYPE check
  77. # 15 feb 2019, 3d-gussner, Added zip files for miniRAMbo multi language hex files
  78. # 15 Feb 2019, 3d-gussner, Added more checks if
  79. # Compiled Hex-files
  80. # Configuration_prusa.h
  81. # language build files
  82. # multi language firmware files exist and clean them up
  83. # 15 Feb 2019, 3d-gussner, Fixed selection GOLD/UNKNOWN DEV_STATUS for ALL variants builds, so you have to choose only once
  84. # 15 Feb 2019, 3d-gussner, Added some colored output
  85. # 15 Feb 2019, 3d-gussner, troubleshooting and minor fixes
  86. # 16 Feb 2019, 3d-gussner, Script can be run using arguments
  87. # $1 = variant, example "1_75mm_MK3-EINSy10a-E3Dv6full.h" at this moment it is not possible to use ALL
  88. # $2 = multi language OR English only [ALL/EN_ONLY]
  89. # $3 = development status [GOLD/RC/BETA/ALPHA/DEVEL/DEBUG]
  90. # If one argument is wrong a list of valid one will be shown
  91. # 13 Mar 2019, 3d-gussner, MKbel updated the Linux build environment to version 1.0.2 with an Fix maximum firmware flash size.
  92. # So did I
  93. # 11 Jul 2019, deliopoulos,Updated to v1.0.6 as Prusa needs a new board definition for Firmware 3.8.x86_64
  94. # - Split the Download of Windows Arduino IDE 1.8.5 and Prusa specific part
  95. # --> less download volume needed and saves some time
  96. #
  97. # 13 Jul 2019, deliopoulos,Splitting of Arduino IDE and Prusa parts also for Linux64
  98. # 13 Jul 2019, 3d-gussner, Added Linux 32-bit version (untested yet)
  99. # MacOS could be added in future if needs
  100. # 14 Jul 2019, 3d-gussner, Update preferences and make it really portable
  101. # 15 Jul 2019, 3d-gussner, New PF-build-env GitHub branch
  102. # 16 Jul 2019, 3d-gussner, New Arduino_boards GitHub fork
  103. # 17 Jul 2019, 3d-gussner, Final tests under Windows 10 and Linux Subsystem for Windows
  104. # 18 Jul 2019, 3d-gussner, Added python check
  105. # 18 Jul 2019, deliopoulos, No need more for changing 'platform.txt' file as it comes with the Arduino Boards.
  106. # 18 Jul 2019, deliopoulos, Modified 'PF_BUILD_FILE_URL' to use 'BUILD_ENV' variable
  107. # 22 Jul 2019, 3d-gussner, Modified checks to check folder and/or installation output exists.
  108. # 22 Jul 2019, 3d-gussner, Added check if Arduino IDE 1.8.5 boards have been updated
  109. # 22 Jul 2019, 3d-gussner, Changed exit numbers 1-13 for prepare build env 21-28 for prepare compiling 31-36 compiling
  110. # 22 Jul 2019, 3d-gussner, Changed BOARD_URL to DRracers repository after he pulled my PR https://github.com/DRracer/Arduino_Boards/pull/1
  111. # 23 Jul 2019, 3d-gussner, Changed Build-env path to "PF-build-dl" as requested in PR https://github.com/prusa3d/Prusa-Firmware/pull/2028
  112. # Changed Hex-files folder to PF-build-hex as requested in PR
  113. # 23 Jul 2019, 3d-gussner, Added Finding OS version routine so supporting new OS should get easier
  114. # 26 Jul 2019, 3d-gussner, Change JSON repository to prusa3d after PR https://github.com/prusa3d/Arduino_Boards/pull/1 was merged
  115. # 23 Sep 2019, 3d-gussner, Prepare PF-build.sh for coming Prusa3d/Arduino_Boards version 1.0.2 Pull Request
  116. # 17 Oct 2019, 3d-gussner, Changed folder and check file names to have separated build environments depending on Arduino IDE version and
  117. # board-versions.
  118. # 15 Dec 2019, 3d-gussner, Prepare for switch to Prusa3d/PF-build-env repository
  119. # 15 Dec 2019, 3d-gussner, Fix Arduino user preferences for the chosen board.
  120. # 17 Dec 2019, 3d-gussner, Fix "timer0_fract = 0" warning by using Arduino_boards v1.0.3
  121. # 28 Apr 2020, 3d-gussner, Added RC3 detection
  122. # 03 May 2020, deliopoulos, Accept all RCx as RC versions
  123. # 05 May 2020, 3d-gussner, Make a copy of `not_tran.txt`and `not_used.txt` as `not_tran_$VARIANT.txt`and `not_used_$VARIANT.txt`
  124. # After compiling All multi-language variants it makes it easier to find missing or unused translations.
  125. # 12 May 2020, DRracer , Cleanup double MK2/s MK25/s `not_tran` and `not_used` files
  126. # 13 May 2020, leptun , If cleanup files do not exist don't try to.
  127. # 01 Oct 2020, 3d-gussner, Bug fix if using argument EN_ONLY. Thank to @leptun for pointing out.
  128. # Change Build number to script commits 'git rev-list --count HEAD PF-build.sh'
  129. # 02 Oct 2020, 3d-gussner, Add UNKNOWN as argument option
  130. # 05 Oct 2020, 3d-gussner, Disable pause and warnings using command line with all needed arguments
  131. # Install needed apps under linux if needed.
  132. # Clean PF-Firmware build when changing git branch
  133. # 02 Nov 2020, 3d-gussner, Check for "gawk" on Linux
  134. # Add argument to change build number automatically to current commit or define own number
  135. # Update exit numbers 1-13 for prepare build env 21-29 for prepare compiling 30-36 compiling
  136. # 08 Jan 2021, 3d-gussner, Comment out 'sudo' auto installation
  137. # Add '-?' '-h' help option
  138. # 27 Jan 2021, 3d-gussner, Add `-c`, `-p` and `-n` options
  139. # 12 Feb 2021, 3d-gussner, Add MK404-build.sh
  140. # 13 Feb 2021, 3d-gussner, Indentations
  141. # 13 Feb 2021, 3d-gussner, MK404 improvements like "flash" MK3, MK3S languages files to MK404 xflash.
  142. # 27 Feb 2021, 3d-gussner, Add './lang-community.sh' and update exits
  143. # 03 May 2021, 3d-gussner, Update exit numbers
  144. # 01-14 prepare build env
  145. # 21-32 prepare compiling
  146. # 41-47 compiling
  147. # 51-54 cleanup
  148. # 61-62 MK404
  149. # 03 May 2021, 3d-gussner, Update documentation and change version to v1.2.0
  150. # 03 May 2021, 3d-gussner, Add SIM atmega404
  151. # 17 Jun 2021, 3d-gussner, Update PF-build.sh to work after DRracer Remove FW version parsing PR
  152. # 17 Jun 2021, 3d-gussner, Save ELF files for FW3.10.1 debugging PRs
  153. # 17 Jun 2021, 3d-gussner, Add verbose_IDE to output more information during build
  154. #### Start check if OSTYPE is supported
  155. OS_FOUND=$( command -v uname)
  156. case $( "${OS_FOUND}" | tr '[:upper:]' '[:lower:]') in
  157. linux*)
  158. TARGET_OS="linux"
  159. ;;
  160. msys*|cygwin*|mingw*)
  161. # or possible 'bash on windows'
  162. TARGET_OS='windows'
  163. ;;
  164. nt|win*)
  165. TARGET_OS='windows'
  166. ;;
  167. *)
  168. TARGET_OS='unknown'
  169. ;;
  170. esac
  171. # Windows
  172. if [ $TARGET_OS == "windows" ]; then
  173. if [ $(uname -m) == "x86_64" ]; then
  174. echo "$(tput setaf 2)Windows 64-bit found$(tput sgr0)"
  175. Processor="64"
  176. elif [ $(uname -m) == "i386" ]; then
  177. echo "$(tput setaf 2)Windows 32-bit found$(tput sgr0)"
  178. Processor="32"
  179. else
  180. echo "$(tput setaf 1)Unsupported OS: Windows $(uname -m)"
  181. echo "Please refer to the notes of build.sh$(tput sgr0)"
  182. exit 1
  183. fi
  184. # Linux
  185. elif [ $TARGET_OS == "linux" ]; then
  186. if [ $(uname -m) == "x86_64" ]; then
  187. echo "$(tput setaf 2)Linux 64-bit found$(tput sgr0)"
  188. Processor="64"
  189. elif [[ $(uname -m) == "i386" || $(uname -m) == "i686" ]]; then
  190. echo "$(tput setaf 2)Linux 32-bit found$(tput sgr0)"
  191. Processor="32"
  192. else
  193. echo "$(tput setaf 1)Unsupported OS: Linux $(uname -m)"
  194. echo "Please refer to the notes of build.sh$(tput sgr0)"
  195. exit 1
  196. fi
  197. else
  198. echo "$(tput setaf 1)This script doesn't support your Operating system!"
  199. echo "Please use Linux 64-bit or Windows 10 64-bit with Linux subsystem / git-bash"
  200. echo "Read the notes of build.sh$(tput sgr0)"
  201. exit 1
  202. fi
  203. sleep 2
  204. #### End check if OSTYPE is supported
  205. #### Prepare bash environment and check if wget, zip and other needed things are available
  206. # Check wget
  207. if ! type wget > /dev/null; then
  208. echo "$(tput setaf 1)Missing 'wget' which is important to run this script"
  209. echo "Please follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058 to install wget$(tput sgr0)"
  210. exit 2
  211. fi
  212. # Check for zip
  213. if ! type zip > /dev/null; then
  214. if [ $TARGET_OS == "windows" ]; then
  215. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  216. echo "Download and install 7z-zip from its official website https://www.7-zip.org/"
  217. echo "By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case."
  218. echo "Run git Bash under Administrator privilege and"
  219. echo "navigate to the directory /c/Program Files/Git/mingw64/bin,"
  220. echo "you can run the command $(tput setaf 2)ln -s /c/Program Files/7-Zip/7z.exe zip.exe$(tput sgr0)"
  221. exit 3
  222. elif [ $TARGET_OS == "linux" ]; then
  223. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  224. echo "install it with the command $(tput setaf 2)'sudo apt-get install zip'$(tput sgr0)"
  225. #sudo apt-get update && apt-get install zip
  226. exit 3
  227. fi
  228. fi
  229. # Check python ... needed during language build
  230. if ! type python > /dev/null; then
  231. if [ $TARGET_OS == "windows" ]; then
  232. echo "$(tput setaf 1)Missing 'python3' which is important to run this script"
  233. exit 4
  234. elif [ $TARGET_OS == "linux" ]; then
  235. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  236. echo "As Python 2.x will not be maintained from 2020 please,"
  237. echo "install it with the command $(tput setaf 2)'sudo apt-get install python3'."
  238. echo "Check which version of Python3 has been installed using 'ls /usr/bin/python3*'"
  239. echo "Use 'sudo ln -sf /usr/bin/python3.x /usr/bin/python' (where 'x' is your version number) to make it default.$(tput sgr0)"
  240. #sudo apt-get update && apt-get install python3 && ln -sf /usr/bin/python3 /usr/bin/python
  241. exit 4
  242. fi
  243. fi
  244. # Check gawk ... needed during language build
  245. if ! type gawk > /dev/null; then
  246. if [ $TARGET_OS == "linux" ]; then
  247. echo "$(tput setaf 1)Missing 'gawk' which is important to run this script"
  248. echo "install it with the command $(tput setaf 2)'sudo apt-get install gawk'."
  249. #sudo apt-get update && apt-get install gawk
  250. exit 5
  251. fi
  252. fi
  253. #### End prepare bash / Linux environment
  254. # Check for options/flags
  255. while getopts b:c:d:f:g:h:i:j:l:m:n:o:p:v:x:?h flag
  256. do
  257. case "${flag}" in
  258. b) build_flag=${OPTARG};;
  259. c) clean_flag=${OPTARG};;
  260. d) devel_flag=${OPTARG};;
  261. f) board_flash_flag=${OPTARG};;
  262. g) graphics_flag=${OPTARG};;
  263. h) help_flag=1;;
  264. i) IDE_flag=${OPTARG};;
  265. j) verbose_IDE_flag=${OPTARG};;
  266. l) language_flag=${OPTARG};;
  267. m) mk404_flag=${OPTARG};;
  268. n) new_build_flag=${OPTARG};;
  269. o) output_flag=${OPTARG};;
  270. p) prusa_flag=${OPTARG};;
  271. v) variant_flag=${OPTARG};;
  272. x) board_mem_flag=${OPTARG};;
  273. ?) help_flag=1;;
  274. esac
  275. done
  276. #
  277. # '?' 'h' argument usage and help
  278. if [ "$help_flag" == "1" ] ; then
  279. echo "***************************************"
  280. echo "* PF-build.sh Version: 1.2.0-Build_54 *"
  281. echo "***************************************"
  282. echo "Arguments:"
  283. echo "$(tput setaf 2)-b$(tput sgr0) Build/commit number '$(tput setaf 2)Auto$(tput sgr0)' needs git or a number"
  284. echo "$(tput setaf 2)-c$(tput sgr0) Do not clean up lang build'$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  285. echo "$(tput setaf 2)-d$(tput sgr0) Devel build '$(tput setaf 2)GOLD$(tput sgr0)', '$(tput setaf 2)RC$(tput sgr0)', '$(tput setaf 2)BETA$(tput sgr0)', '$(tput setaf 2)ALPHA$(tput sgr0)', '$(tput setaf 2)DEBUG$(tput sgr0)', '$(tput setaf 2)DEVEL$(tput sgr0)' and '$(tput setaf 2)UNKNOWN$(tput sgr0)'"
  286. echo "$(tput setaf 2)-f$(tput sgr0) Board flash size '$(tput setaf 2)256$(tput sgr0)','$(tput setaf 2)384$(tput sgr0)','$(tput setaf 2)512$(tput sgr0)','$(tput setaf 2)1024$(tput sgr0)''$(tput setaf 2)32M$(tput sgr0)'"
  287. echo "$(tput setaf 2)-g$(tput sgr0) Start MK404 grafics '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' lite '$(tput setaf 2)2$(tput sgr0)' fancy"
  288. echo "$(tput setaf 2)-h$(tput sgr0) Help"
  289. echo "$(tput setaf 2)-i$(tput sgr0) Arduino IDE version '$(tput setaf 2)1.8.5$(tput sgr0)', '$(tput setaf 2)1.8.13$(tput sgr0)'"
  290. echo "$(tput setaf 2)-j$(tput sgr0) Arduino IDE verbose output '$(tput setaf 2)0$(tput sgr0)', '$(tput setaf 2)1$(tput sgr0) active'"
  291. echo "$(tput setaf 2)-l$(tput sgr0) Languages '$(tput setaf 2)ALL$(tput sgr0)' for multi language or '$(tput setaf 2)EN_ONLY$(tput sgr0)' for English only"
  292. echo "$(tput setaf 2)-m$(tput sgr0) Start MK404 sim '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes '$(tput setaf 2)2$(tput sgr0)' with MMU2"
  293. echo "$(tput setaf 2)-n$(tput sgr0) New fresh build '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  294. echo "$(tput setaf 2)-o$(tput sgr0) Output '$(tput setaf 2)1$(tput sgr0)' force or '$(tput setaf 2)0$(tput sgr0)' block output and delays"
  295. echo "$(tput setaf 2)-p$(tput sgr0) Keep Configuration_prusa.h '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  296. echo "$(tput setaf 2)-v$(tput sgr0) Variant '$(tput setaf 2)All$(tput sgr0)' or variant file name"
  297. echo "$(tput setaf 2)-x$(tput sgr0) Board memory size '$(tput setaf 2)8$(tput sgr0)' or '$(tput setaf 2)64$(tput sgr0)' Kb."
  298. echo "$(tput setaf 2)-?$(tput sgr0) Help"
  299. echo
  300. echo "Brief USAGE:"
  301. echo " $(tput setaf 2)./PF-build.sh$(tput sgr0) [-v] [-l] [-d] [-b] [-o] [-c] [-p] [-n]"
  302. echo
  303. echo "Example:"
  304. echo " $(tput setaf 2)./PF-build.sh -v All -l ALL -d GOLD$(tput sgr0)"
  305. echo " Will build all variants as multi language and final GOLD version"
  306. echo
  307. echo " $(tput setaf 2) ./PF-build.sh -v 1_75mm_MK3S-EINSy10a-E3Dv6full.h -b Auto -l ALL -d GOLD -o 1 -c 1 -p 1 -n 1$(tput sgr0)"
  308. echo " Will build MK3S multi language final GOLD firmware "
  309. echo " with current commit count number and output extra information,"
  310. echo " not delete lang build temporary files, keep Configuration_prusa.h and build with new fresh build folder."
  311. echo
  312. exit 6
  313. fi
  314. #Check if verbose_IDE is selected with argument '-j'
  315. if [ ! -z "$verbose_IDE_flag" ]; then
  316. if [ $verbose_IDE_flag == "1" ]; then
  317. verbose_IDE="1"
  318. elif [ $verbose_IDE_flag == "0" ]; then
  319. verbose_IDE="0"
  320. else
  321. echo "Only '0' and '1' are valid verbose_IDE values."
  322. exit
  323. fi
  324. else
  325. verbose_IDE="0"
  326. fi
  327. #Check if Build is selected with argument '-f'
  328. if [ ! -z "$board_flash_flag" ] ; then
  329. if [ "$board_flash_flag" == "256" ] ; then
  330. BOARD_FLASH="0x3FFFF"
  331. BOARD_maximum_size="253952"
  332. echo "Board flash size : $board_flash_flag Kb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  333. elif [ "$board_flash_flag" == "384" ] ; then
  334. BOARD_FLASH="0x5FFFF"
  335. BOARD_maximum_size="385024"
  336. echo "Board flash size : $board_flash_flag Kb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  337. elif [ "$board_flash_flag" == "512" ] ; then
  338. BOARD_FLASH="0x7FFFF"
  339. BOARD_maximum_size="516096"
  340. echo "Board flash size : $board_flash_flag Kb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  341. elif [ "$board_flash_flag" == "1024" ] ; then
  342. BOARD_FLASH="0xFFFFF"
  343. BOARD_maximum_size="1040384"
  344. echo "Board flash size : $board_flash_flag Kb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  345. elif [[ "$board_flash_flag" == "32M" || "$board_flash_flag" == "32768" ]] ; then
  346. BOARD_FLASH="0x1FFFFFF"
  347. BOARD_maximum_size="33546240"
  348. echo "Board flash size : 32 Mb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  349. else
  350. echo "Unsupported board flash size chosen. Only '256', '384', '512', '1024' and '32M' are allowed."
  351. exit 7
  352. fi
  353. fi
  354. #Check if Build is selected with argument '-x'
  355. if [ ! -z "$board_mem_flag" ] ; then
  356. if [ "$board_mem_flag" == "8" ] ; then
  357. BOARD_MEM="0x21FF"
  358. echo "Board mem size : $board_mem_flag Kb, $BOARD_MEM (hex)"
  359. elif [ "$board_mem_flag" == "64" ] ; then
  360. BOARD_MEM="0xFFFF"
  361. echo "Board mem size : $board_mem_flag Kb, $BOARD_MEM (hex)"
  362. else
  363. echo "Unsupported board mem size chosen. Only '8', '64' are allowed."
  364. exit 8
  365. fi
  366. fi
  367. #Check if Arduino IDE version is correct
  368. if [ ! -z "$IDE_flag" ]; then
  369. if [[ "$IDE_flag" == "1.8.5" || "$IDE_flag" == "1.8.13" ]]; then
  370. ARDUINO_ENV="${IDE_flag}"
  371. else
  372. ARDUINO_ENV="1.8.5"
  373. fi
  374. else
  375. ARDUINO_ENV="1.8.5"
  376. fi
  377. #### Set build environment
  378. BUILD_ENV="1.0.6"
  379. BOARD="prusa_einsy_rambo"
  380. BOARD_PACKAGE_NAME="PrusaResearch"
  381. BOARD_VERSION="1.0.3"
  382. #BOARD_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
  383. BOARD_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
  384. BOARD_FILENAME="prusa3dboards"
  385. #BOARD_FILE_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/master/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  386. BOARD_FILE_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  387. #PF_BUILD_FILE_URL="https://github.com/3d-gussner/PF-build-env-1/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  388. PF_BUILD_FILE_URL="https://github.com/prusa3d/PF-build-env/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  389. LIB="PrusaLibrary"
  390. SCRIPT_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  391. # List few useful data
  392. echo
  393. echo "Script path :" $SCRIPT_PATH
  394. echo "OS :" $OS
  395. echo "OS type :" $TARGET_OS
  396. echo ""
  397. echo "Arduino IDE :" $ARDUINO_ENV
  398. echo "Build env :" $BUILD_ENV
  399. echo "Board :" $BOARD
  400. if [ ! -z "$BOARD_FLASH" ] ; then
  401. echo "Board flash :" $BOARD_FLASH
  402. fi
  403. if [ ! -z "$BOARD_MEM" ] ; then
  404. echo "Board mem :" $BOARD_MEM
  405. fi
  406. echo "Package name:" $BOARD_PACKAGE_NAME
  407. echo "Board v. :" $BOARD_VERSION
  408. echo "Specific Lib:" $LIB
  409. echo ""
  410. #### Start prepare building environment
  411. #Check if build exists and creates it if not
  412. if [ ! -d "../PF-build-dl" ]; then
  413. mkdir ../PF-build-dl || exit 9
  414. fi
  415. cd ../PF-build-dl || exit 10
  416. BUILD_ENV_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  417. # Check if PF-build-env-<version> exists and downloads + creates it if not
  418. # The build environment is based on the supported Arduino IDE portable version with some changes
  419. if [ ! -d "../PF-build-env-$BUILD_ENV" ]; then
  420. echo "$(tput setaf 6)PF-build-env-$BUILD_ENV is missing ... creating it now for you$(tput sgr 0)"
  421. mkdir ../PF-build-env-$BUILD_ENV
  422. sleep 5
  423. fi
  424. # Download and extract supported Arduino IDE depending on OS
  425. # Windows
  426. if [ $TARGET_OS == "windows" ]; then
  427. if [ ! -f "arduino-$ARDUINO_ENV-windows.zip" ]; then
  428. echo "$(tput setaf 6)Downloading Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  429. sleep 2
  430. wget https://downloads.arduino.cc/arduino-$ARDUINO_ENV-windows.zip || exit 8
  431. echo "$(tput sgr 0)"
  432. fi
  433. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  434. echo "$(tput setaf 6)Unzipping Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  435. sleep 2
  436. unzip arduino-$ARDUINO_ENV-windows.zip -d ../PF-build-env-$BUILD_ENV || exit 9
  437. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  438. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  439. echo "$(tput sgr0)"
  440. fi
  441. fi
  442. # Linux
  443. if [ $TARGET_OS == "linux" ]; then
  444. # 32 or 64 bit version
  445. if [ ! -f "arduino-$ARDUINO_ENV-linux$Processor.tar.xz" ]; then
  446. echo "$(tput setaf 6)Downloading Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  447. sleep 2
  448. wget --no-check-certificate https://downloads.arduino.cc/arduino-$ARDUINO_ENV-linux$Processor.tar.xz || exit 8
  449. echo "$(tput sgr 0)"
  450. fi
  451. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  452. echo "$(tput setaf 6)Unzipping Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  453. sleep 2
  454. tar -xvf arduino-$ARDUINO_ENV-linux$Processor.tar.xz -C ../PF-build-env-$BUILD_ENV/ || exit 9
  455. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  456. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  457. echo "$(tput sgr0)"
  458. fi
  459. fi
  460. # Make Arduino IDE portable
  461. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/ ]; then
  462. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/
  463. fi
  464. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/ ]; then
  465. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable
  466. fi
  467. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output/ ]; then
  468. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output
  469. fi
  470. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/ ]; then
  471. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages
  472. fi
  473. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/ ]; then
  474. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook
  475. fi
  476. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries/ ]; then
  477. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries
  478. fi
  479. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging/ ]; then
  480. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging
  481. fi
  482. # Change Arduino IDE preferences
  483. if [ ! -e ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt ]; then
  484. echo "$(tput setaf 6)Setting $ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor Arduino IDE preferences for portable GUI usage...$(tput setaf 2)"
  485. sleep 2
  486. echo "update.check"
  487. sed -i 's/update.check = true/update.check = false/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  488. echo "board"
  489. sed -i "s/board = uno/board = $BOARD/g" ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  490. echo "editor.linenumbers"
  491. sed -i 's/editor.linenumbers = false/editor.linenumbers = true/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  492. echo "boardsmanager.additional.urls"
  493. echo "boardsmanager.additional.urls=$BOARD_URL" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  494. echo "build.verbose=true" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  495. echo "compiler.cache_core=false" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  496. echo "compiler.warning_level=all" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  497. echo "# Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  498. echo "$(tput sgr0)"
  499. fi
  500. # Download and extract Prusa Firmware related parts
  501. # Download and extract PrusaResearchRambo board
  502. if [ ! -f "$BOARD_FILENAME-$BOARD_VERSION.tar.bz2" ]; then
  503. echo "$(tput setaf 6)Downloading Prusa Research AVR MK3 RAMBo EINSy build environment...$(tput setaf 2)"
  504. sleep 2
  505. wget $BOARD_FILE_URL || exit 10
  506. fi
  507. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION" || ! -e "../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  508. echo "$(tput setaf 6)Unzipping $BOARD_PACKAGE_NAME Arduino IDE portable...$(tput setaf 2)"
  509. sleep 2
  510. tar -xvf $BOARD_FILENAME-$BOARD_VERSION.tar.bz2 -C ../PF-build-env-$BUILD_ENV/ || exit 11
  511. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  512. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  513. fi
  514. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  515. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  516. fi
  517. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware ]; then
  518. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware
  519. fi
  520. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr ]; then
  521. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr
  522. fi
  523. mv ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$BOARD_VERSION ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION
  524. echo "# $BOARD_FILENAME-$BOARD_VERSION" >> ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  525. echo "$(tput sgr 0)"
  526. fi
  527. # Download and extract Prusa Firmware specific library files
  528. if [ ! -f "PF-build-env-WinLin-$BUILD_ENV.zip" ]; then
  529. echo "$(tput setaf 6)Downloading Prusa Firmware build environment...$(tput setaf 2)"
  530. sleep 2
  531. wget $PF_BUILD_FILE_URL || exit 12
  532. echo "$(tput sgr 0)"
  533. fi
  534. if [ ! -e "../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]; then
  535. echo "$(tput setaf 6)Unzipping Prusa Firmware build environment...$(tput setaf 2)"
  536. sleep 2
  537. unzip -o PF-build-env-WinLin-$BUILD_ENV.zip -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 13
  538. echo "# PF-build-env-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  539. echo "$(tput sgr0)"
  540. fi
  541. # Check if User updated Arduino IDE 1.8.5 boardsmanager and tools
  542. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools" ]; then
  543. echo "$(tput setaf 6)Arduino IDE boards / tools have been manually updated...$"
  544. echo "Please don't update the 'Arduino AVR boards' as this will prevent running this script (tput setaf 2)"
  545. sleep 2
  546. fi
  547. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2" ]; then
  548. echo "$(tput setaf 6)PrusaReasearch compatible tools have been manually updated...$(tput setaf 2)"
  549. sleep 2
  550. echo "$(tput setaf 6)Copying Prusa Firmware build environment to manually updated boards / tools...$(tput setaf 2)"
  551. sleep 2
  552. cp -f ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/hardware/tools/avr/avr/lib/ldscripts/avr6.xn ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2/avr/lib/ldscripts/avr6.xn
  553. echo "# PF-build-env-portable-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-portable-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  554. echo "$(tput sgr0)"
  555. fi
  556. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/5.4.0-atmel3.6.1-arduino2" ]; then
  557. echo "$(tput setaf 1)Arduino IDE tools have been updated manually to a non supported version!!!"
  558. echo "Delete ../PF-build-env-$BUILD_ENV and start the script again"
  559. echo "Script will not continue until this have been fixed $(tput setaf 2)"
  560. sleep 2
  561. echo "$(tput sgr0)"
  562. exit 14
  563. fi
  564. #### End prepare building
  565. #### Start
  566. cd $SCRIPT_PATH
  567. # Check if git is available
  568. if type git > /dev/null; then
  569. git_available="1"
  570. fi
  571. #
  572. # '-v' argument defines which variant of the Prusa Firmware will be compiled
  573. if [ -z "$variant_flag" ] ; then
  574. # Select which variant of the Prusa Firmware will be compiled, like
  575. PS3="Select a variant: "
  576. while IFS= read -r -d $'\0' f; do
  577. options[i++]="$f"
  578. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  579. select opt in "${options[@]}" "All" "Quit"; do
  580. case $opt in
  581. *.h)
  582. VARIANT=$(basename "$opt" ".h")
  583. VARIANTS[i++]="$opt"
  584. break
  585. ;;
  586. "All")
  587. VARIANT="All"
  588. VARIANTS=${options[*]}
  589. break
  590. ;;
  591. "Quit")
  592. echo "You chose to stop"
  593. exit 22
  594. ;;
  595. *)
  596. echo "$(tput setaf 1)This is not a valid variant$(tput sgr0)"
  597. ;;
  598. esac
  599. done
  600. else
  601. if [ -f "$SCRIPT_PATH/Firmware/variants/$variant_flag" ] ; then
  602. VARIANTS=$variant_flag
  603. elif [ "$variant_flag" == "All" ] ; then
  604. while IFS= read -r -d $'\0' f; do
  605. options[i++]="$f"
  606. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  607. VARIANT="All"
  608. VARIANTS=${options[*]}
  609. else
  610. echo "$(tput setaf 1)Argument $variant_flag could not be found in Firmware/variants please choose a valid one.$(tput sgr0)"
  611. echo "Only $(tput setaf 2)'All'$(tput sgr0) and file names below are allowed as variant '-v' argument.$(tput setaf 2)"
  612. ls -1 $SCRIPT_PATH/Firmware/variants/*.h | xargs -n1 basename
  613. echo "$(tput sgr0)"
  614. exit 23
  615. fi
  616. fi
  617. #'-l' argument defines if it is an English only version. Known values EN_ONLY / ALL
  618. #Check default language mode
  619. MULTI_LANGUAGE_CHECK=$(grep --max-count=1 "^#define LANG_MODE *" $SCRIPT_PATH/Firmware/config.h|sed -e's/ */ /g'|cut -d ' ' -f3)
  620. if [ -z "$language_flag" ] ; then
  621. PS3="Select a language: "
  622. echo
  623. echo "Which lang-build do you want?"
  624. select yn in "Multi languages" "English only"; do
  625. case $yn in
  626. "Multi languages")
  627. LANGUAGES="ALL"
  628. break
  629. ;;
  630. "English only")
  631. LANGUAGES="EN_ONLY"
  632. break
  633. ;;
  634. *)
  635. echo "$(tput setaf 1)This is not a valid language$(tput sgr0)"
  636. ;;
  637. esac
  638. done
  639. else
  640. if [[ "$language_flag" == "ALL" || "$language_flag" == "EN_ONLY" ]] ; then
  641. LANGUAGES=$language_flag
  642. else
  643. echo "$(tput setaf 1)Language argument is wrong!$(tput sgr0)"
  644. echo "Only $(tput setaf 2)'ALL'$(tput sgr0) or $(tput setaf 2)'EN_ONLY'$(tput sgr0) are allowed as language '-l' argument!"
  645. exit 24
  646. fi
  647. fi
  648. #Check if DEV_STATUS is selected via argument '-d'
  649. if [ ! -z "$devel_flag" ] ; then
  650. if [[ "$devel_flag" == "GOLD" || "$devel_flag" == "RC" || "$devel_flag" == "BETA" || "$devel_flag" == "ALPHA" || "$devel_flag" == "DEVEL" || "$devel_flag" == "DEBUG" || "$devel_flag" == "UNKNOWN" ]] ; then
  651. DEV_STATUS_SELECTED=$devel_flag
  652. elif [[ "$devel_flag" == "atmega404" || "$devel_flag" == "atmega404_no_bootloader" ]] ; then
  653. MK404_DEBUG=$devel_flag
  654. else
  655. echo "$(tput setaf 1)Development argument is wrong!$(tput sgr0)"
  656. echo "Only $(tput setaf 2)'GOLD', 'RC', 'BETA', 'ALPHA', 'DEVEL', 'DEBUG' or 'UNKNOWN' $(tput sgr0) are allowed as devel '-d' argument!$(tput sgr0)"
  657. exit 25
  658. fi
  659. fi
  660. #Check if Build is selected via argument '-b'
  661. if [ ! -z "$build_flag" ] ; then
  662. if [[ "$build_flag" == "Auto" && "$git_available" == "1" ]] ; then
  663. echo "Build changed to $build_flag"
  664. BUILD=$(git rev-list --count HEAD)
  665. elif [[ $build_flag =~ ^[0-9]+$ ]] ; then
  666. BUILD=$build_flag
  667. else
  668. echo "$(tput setaf 1)Build number argument is wrong!$(tput sgr0)"
  669. echo "Only $(tput setaf 2)'Auto' (git needed) or numbers $(tput sgr0) are allowed as build '-b' argument!$(tput sgr0)"
  670. exit 26
  671. fi
  672. echo "New Build number is: $BUILD"
  673. fi
  674. # check if script has been started with arguments
  675. if [[ "$#" -eq "0" || "$output_flag" == 1 ]] ; then
  676. OUTPUT=1
  677. else
  678. OUTPUT=0
  679. fi
  680. #echo "Output is:" $OUTPUT
  681. #Check git branch has changed
  682. if [ ! -z "git_available" ]; then
  683. BRANCH=""
  684. CLEAN_PF_FW_BUILD=0
  685. else
  686. BRANCH=$(git branch --show-current)
  687. echo "Current branch is:" $BRANCH
  688. if [ ! -f "$SCRIPT_PATH/../PF-build.branch" ]; then
  689. echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
  690. echo "created PF-build.branch file"
  691. else
  692. PRE_BRANCH=$(cat "$SCRIPT_PATH/../PF-build.branch")
  693. echo "Previous branch was:" $PRE_BRANCH
  694. if [ ! "$BRANCH" == "$PRE_BRANCH" ] ; then
  695. CLEAN_PF_FW_BUILD=1
  696. echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
  697. fi
  698. fi
  699. fi
  700. #Set BUILD_ENV_PATH
  701. cd ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 27
  702. BUILD_ENV_PATH="$( pwd -P )"
  703. cd ../..
  704. #Checkif BUILD_PATH exists and if not creates it
  705. if [ ! -d "Prusa-Firmware-build" ]; then
  706. mkdir Prusa-Firmware-build || exit 28
  707. fi
  708. #Set the BUILD_PATH for Arduino IDE
  709. cd Prusa-Firmware-build || exit 29
  710. BUILD_PATH="$( pwd -P )"
  711. #Check git branch has changed
  712. if [ "$CLEAN_PF_FW_BUILD" == "1" ]; then
  713. read -t 10 -p "Branch changed, cleaning Prusa-Firmware-build folder"
  714. rm -r *
  715. else
  716. echo "Nothing to clean up"
  717. fi
  718. for v in ${VARIANTS[*]}
  719. do
  720. VARIANT=$(basename "$v" ".h")
  721. MK404_PRINTER=$(grep --max-count=1 "\bPRINTER_TYPE\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3 | cut -d '_' -f2)
  722. # Find firmware version in Configuration.h file and use it to generate the hex filename
  723. FW_MAJOR=$(grep --max-count=1 "\bFW_MAJOR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  724. FW_MINOR=$(grep --max-count=1 "\bFW_MINOR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  725. FW_REVISION=$(grep --max-count=1 "\bFW_REVISION\b" $SCRIPT_PATH/Firmware/Configuration.h| sed -e's/ */ /g'|cut -d ' ' -f3)
  726. FW="$FW_MAJOR$FW_MINOR$FW_REVISION"
  727. #FW=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g')
  728. if [ -z "$BUILD" ] ; then
  729. # Find build version in Configuration.h file and use it to generate the hex filename
  730. BUILD=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  731. else
  732. # Find and replace build version in Configuration.h file
  733. BUILD_ORG=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  734. echo "Original build number: $BUILD_ORG"
  735. sed -i -- "s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD/g" $SCRIPT_PATH/Firmware/Configuration.h
  736. fi
  737. # Check if the motherboard is an EINSY and if so only one hex file will generated
  738. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  739. # Check development status
  740. FW_FLAV=$(grep --max-count=1 "//#define FW_FLAVOR\b" $SCRIPT_PATH/Firmware/Configuration.h|cut -d ' ' -f1)
  741. if [[ "$FW_FLAV" != "//#define" ]] ; then
  742. FW_FLAVOR=$(grep --max-count=1 "\bFW_FLAVOR\b" $SCRIPT_PATH/Firmware/Configuration.h| sed -e's/ */ /g'|cut -d ' ' -f3)
  743. FW_FLAVERSION=$(grep --max-count=1 "\bFW_FLAVERSION\b" $SCRIPT_PATH/Firmware/Configuration.h| sed -e's/ */ /g'|cut -d ' ' -f3)
  744. if [[ "$FW_FLAVOR" != "//#define FW_FLAVOR" ]] ; then
  745. FW="$FW-$FW_FLAVOR"
  746. DEV_CHECK="$FW_FLAVOR"
  747. if [ ! -z "$FW_FLAVERSION" ] ; then
  748. FW="$FW$FW_FLAVERSION"
  749. fi
  750. fi
  751. fi
  752. DEV_CHECK=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g'|cut -d '-' -f2)
  753. if [ -z "$DEV_STATUS_SELECTED" ] ; then
  754. if [[ "$DEV_CHECK" == *"RC"* ]] ; then
  755. DEV_STATUS="RC"
  756. elif [[ "$DEV_CHECK" == *"ALPHA"* ]]; then
  757. DEV_STATUS="ALPHA"
  758. elif [[ "$DEV_CHECK" == *"BETA"* ]]; then
  759. DEV_STATUS="BETA"
  760. elif [[ "$DEV_CHECK" == "DEVEL" ]]; then
  761. DEV_STATUS="DEVEL"
  762. elif [[ "$DEV_CHECK" == "DEBUG" ]]; then
  763. DEV_STATUS="DEBUG"
  764. else
  765. DEV_STATUS="UNKNOWN"
  766. echo
  767. echo "$(tput setaf 5)DEV_STATUS is UNKNOWN. Do you wish to set DEV_STATUS to GOLD?$(tput sgr0)"
  768. PS3="Select YES only if source code is tested and trusted: "
  769. select yn in "Yes" "No"; do
  770. case $yn in
  771. Yes)
  772. DEV_STATUS="GOLD"
  773. DEV_STATUS_SELECTED="GOLD"
  774. break
  775. ;;
  776. No)
  777. DEV_STATUS="UNKNOWN"
  778. DEV_STATUS_SELECTED="UNKNOWN"
  779. break
  780. ;;
  781. *)
  782. echo "$(tput setaf 1)This is not a valid DEV_STATUS$(tput sgr0)"
  783. ;;
  784. esac
  785. done
  786. fi
  787. else
  788. DEV_STATUS=$DEV_STATUS_SELECTED
  789. fi
  790. #Prepare hex files folders
  791. if [ ! -d "$SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD" ]; then
  792. mkdir -p $SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD || exit 28
  793. fi
  794. OUTPUT_FOLDER="PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD"
  795. if [ "$BOARD" != "prusa_einsy_rambo" ]; then
  796. if [ ! -d "$SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$BOARD" ]; then
  797. mkdir -p $SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$BOARD || exit 28
  798. fi
  799. OUTPUT_FOLDER="PF-build-hex/FW$FW-Build$BUILD/$BOARD"
  800. fi
  801. #Check if exactly the same hexfile already exists
  802. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex" && "$LANGUAGES" == "ALL" ]]; then
  803. echo ""
  804. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex | xargs -n1 basename
  805. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  806. if [ $OUTPUT == "1" ] ; then
  807. read -t 10 -p "Press Enter to continue..."
  808. fi
  809. elif [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex" && "$LANGUAGES" == "EN_ONLY" ]]; then
  810. echo ""
  811. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex | xargs -n1 basename
  812. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  813. if [ $OUTPUT == "1" ] ; then
  814. read -t 10 -p "Press Enter to continue..."
  815. fi
  816. fi
  817. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip" && "$LANGUAGES" == "ALL" ]]; then
  818. echo ""
  819. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip | xargs -n1 basename
  820. echo "$(tput setaf 6)This zip file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  821. if [ $OUTPUT == "1" ] ; then
  822. read -t 10 -p "Press Enter to continue..."
  823. fi
  824. fi
  825. #List some useful data
  826. echo "$(tput setaf 2)$(tput setab 7) "
  827. echo "Printer :" $MK404_PRINTER
  828. echo "Variant :" $VARIANT
  829. echo "Firmware :" $FW
  830. echo "Build # :" $BUILD
  831. echo "Dev Check :" $DEV_CHECK
  832. echo "DEV Status :" $DEV_STATUS
  833. echo "Motherboard:" $MOTHERBOARD
  834. echo "Board flash:" $BOARD_FLASH
  835. echo "Board mem :" $BOARD_MEM
  836. echo "Languages :" $LANGUAGES
  837. echo "Hex-file Folder:" $OUTPUT_FOLDER
  838. echo "$(tput sgr0)"
  839. #Prepare Firmware to be compiled by copying variant as Configuration_prusa.h
  840. if [ ! -f "$SCRIPT_PATH/Firmware/Configuration_prusa.h" ]; then
  841. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 31
  842. else
  843. echo "$(tput setaf 6)Configuration_prusa.h already exist it will be overwritten in 10 seconds by the chosen variant.$(tput sgr 0)"
  844. if [ $OUTPUT == "1" ] ; then
  845. read -t 10 -p "Press Enter to continue..."
  846. fi
  847. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 31
  848. fi
  849. #Prepare Configuration.h to use the correct FW_DEV_VERSION to prevent LCD messages when connecting with OctoPrint
  850. sed -i -- "s/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/g" $SCRIPT_PATH/Firmware/Configuration.h
  851. # set FW_REPOSITORY
  852. sed -i -- 's/#define FW_REPOSITORY "Unknown"/#define FW_REPOSITORY "Prusa3d"/g' $SCRIPT_PATH/Firmware/Configuration.h
  853. #Prepare English only or multi-language version to be build
  854. if [ $LANGUAGES == "EN_ONLY" ]; then
  855. echo " "
  856. echo "English only language firmware will be built"
  857. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE 0/g" $SCRIPT_PATH/Firmware/config.h
  858. echo " "
  859. else
  860. echo " "
  861. echo "Multi-language firmware will be built"
  862. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE 1/g" $SCRIPT_PATH/Firmware/config.h
  863. echo " "
  864. fi
  865. #Check if compiler flags are set to Prusa specific needs for the rambo board.
  866. #if [ $TARGET_OS == "windows" ]; then
  867. #RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
  868. #fi
  869. #New fresh PF-Firmware-build
  870. if [ "$new_build_flag" == "1" ]; then
  871. rm -r -f $BUILD_PATH/* || exit 54
  872. fi
  873. # Prepare Board mem and flash modifications
  874. ## Check board mem size
  875. CURRENT_BOARD_MEM=$(grep "#define RAMEND" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h | sed -e's/.* //g'|cut -d ' ' -f3|tr -d $'\n')
  876. if [ $CURRENT_BOARD_MEM != "0x21FF" ] ; then
  877. echo "Board mem has been already modified or not reset"
  878. echo "Current:" $CURRENT_BOARD_MEM
  879. PS3="Select $(tput setaf 2)Yes$(tput sgr 0) if you want to reset it."
  880. select yn in "Yes" "No"; do
  881. case $yn in
  882. Yes)
  883. echo "Resetting board mem size"
  884. sed -i -- "s/^#define RAMEND .*$/#define RAMEND 0x21FF/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  885. break
  886. ;;
  887. *)
  888. echo "Continuing with modified mem size"
  889. break
  890. ;;
  891. esac
  892. done
  893. fi
  894. ## Modify board mem size
  895. if [[ ! -z $BOARD_MEM && "$BOARD_MEM" != "0x21FF" ]] ; then
  896. echo "$(tput setaf 3)Modifying board memory size (hex):$(tput sgr 0)"
  897. echo "Old:" $CURRENT_BOARD_MEM
  898. echo "New:" $BOARD_MEM
  899. read -t 5 -p "To cancel press $(tput setaf 1)CRTL+C$(tput sgr 0)"
  900. echo ""
  901. sed -i -- "s/^#define RAMEND 0x21FF/#define RAMEND ${BOARD_MEM}/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  902. fi
  903. ## Check board flash size
  904. CURRENT_BOARD_FLASH=$(grep "#define FLASHEND" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h | sed -e's/.* //g'|cut -d ' ' -f3|tr -d $'\n')
  905. CURRENT_BOARD_maximum_size=$(grep "prusa_einsy_rambo.upload.maximum_size" $BUILD_ENV_PATH/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION/boards.txt |cut -d '=' -f2|tr -d $'\n')
  906. if [[ $CURRENT_BOARD_FLASH != "0x3FFFF" || $CURRENT_BOARD_maximum_size != "253952" ]] ; then
  907. echo "Board flash has been already modified or not reset"
  908. echo "Current flash size:" $CURRENT_BOARD_FLASH
  909. echo "Current max. size:" $CURRENT_BOARD_maximum_size
  910. PS3="Select $(tput setaf 2)Yes$(tput sgr 0) if you want to reset it."
  911. select yn in "Yes" "No"; do
  912. case $yn in
  913. Yes)
  914. echo "$(tput setaf 1)Resetting board flash size$(tput sgr 0)"
  915. sed -i -- "s/^#define FLASHEND .*$/#define FLASHEND 0x3FFFF/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  916. sed -i -- "s/^prusa_einsy_rambo.upload.maximum_size.*/prusa_einsy_rambo.upload.maximum_size=253952/g" $BUILD_ENV_PATH/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION/boards.txt
  917. break
  918. ;;
  919. *)
  920. echo "$(tput setaf 3)Continuing with modified flash size$(tput sgr 0)"
  921. break
  922. ;;
  923. esac
  924. done
  925. fi
  926. ## Modify boad flash size
  927. if [[ ! -z $BOARD_FLASH && "$BOARD_FLASH" != "0x3FFFF" ]] ; then
  928. echo "Modifying board flash size (hex):"
  929. echo "Old flash size:" $CURRENT_BOARD_FLASH
  930. echo "New flash size:" $BOARD_FLASH
  931. echo "Old max. size:" $CURRENT_BOARD_maximum_size
  932. echo "New max. size:" $BOARD_maximum_size
  933. read -t 5 -p "To cancel press $(tput setaf 1)CRTL+C$(tput sgr 0)"
  934. sed -i -- "s/^#define FLASHEND .*/#define FLASHEND ${BOARD_FLASH}/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  935. sed -i -- "s/^prusa_einsy_rambo.upload.maximum_size.*/prusa_einsy_rambo.upload.maximum_size=${BOARD_maximum_size}/g" $BUILD_ENV_PATH/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION/boards.txt
  936. fi
  937. #Check if compiler flags are set to Prusa specific needs for the rambo board.
  938. # if [ $TARGET_OS == "windows" ]; then
  939. # RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
  940. # fi
  941. #### End of Prepare building
  942. #### Start building
  943. export ARDUINO=$BUILD_ENV_PATH
  944. #echo $BUILD_ENV_PATH
  945. #export BUILDER=$ARDUINO/arduino-builder
  946. echo
  947. #read -t 5 -p "Press Enter..."
  948. echo
  949. echo "Start to build Prusa Firmware ..."
  950. echo "Using variant $VARIANT$(tput setaf 3)"
  951. if [ $OUTPUT == "1" ] ; then
  952. sleep 2
  953. fi
  954. if [ $verbose_IDE == "1" ]; then
  955. $BUILD_ENV_PATH/arduino-builder -dump-prefs -debug-level 10 -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 41
  956. fi
  957. $BUILD_ENV_PATH/arduino-builder -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all -verbose=$verbose_IDE $SCRIPT_PATH/Firmware/Firmware.ino || exit 42
  958. echo "$(tput sgr 0)"
  959. if [ $LANGUAGES == "ALL" ]; then
  960. echo "$(tput setaf 2)"
  961. echo "Building multi language firmware" $MULTI_LANGUAGE_CHECK
  962. echo "$(tput sgr 0)"
  963. if [ $OUTPUT == "1" ] ; then
  964. sleep 2
  965. fi
  966. cd $SCRIPT_PATH/lang
  967. echo "$(tput setaf 3)"
  968. ./config.sh || exit 43
  969. echo "$(tput sgr 0)"
  970. # Check if previous languages and firmware build exist and if so clean them up
  971. if [ -f "lang_en.tmp" ]; then
  972. echo ""
  973. echo "$(tput setaf 6)Previous lang build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  974. if [ $OUTPUT == "1" ] ; then
  975. read -t 10 -p "Press Enter to continue..."
  976. fi
  977. echo "$(tput setaf 3)"
  978. ./lang-clean.sh
  979. echo "$(tput sgr 0)"
  980. fi
  981. if [ -f "progmem.out" ]; then
  982. echo ""
  983. echo "$(tput setaf 6)Previous firmware build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  984. if [ $OUTPUT == "1" ] ; then
  985. read -t 10 -p "Press Enter to continue..."
  986. fi
  987. echo "$(tput setaf 3)"
  988. ./fw-clean.sh
  989. echo "$(tput sgr 0)"
  990. fi
  991. # build languages
  992. echo "$(tput setaf 3)"
  993. ./lang-build.sh || exit 44
  994. # build community languages
  995. ./lang-community.sh || exit 45
  996. # Combine compiled firmware with languages
  997. ./fw-build.sh || exit 46
  998. cp not_tran.txt not_tran_$VARIANT.txt
  999. cp not_used.txt not_used_$VARIANT.txt
  1000. echo "$(tput sgr 0)"
  1001. # Check if the motherboard is an EINSY and if so only one hex file will generated
  1002. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  1003. # If the motherboard is an EINSY just copy one hexfile
  1004. if [ "$MOTHERBOARD" = "BOARD_EINSY_1_0a" ]; then
  1005. echo "$(tput setaf 2)Copying multi language firmware for MK3/Einsy board to PF-build-hex folder$(tput sgr 0)"
  1006. # Make a copy of "lang.bin" for MK404 MK3 and MK3S
  1007. if [ ! -z "$mk404_flag" ]; then
  1008. cp -f lang.bin $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-lang.bin
  1009. fi
  1010. # End of "lang.bin" for MK3 and MK3S copy
  1011. cp -f firmware.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  1012. cp -f $BUILD_PATH/Firmware.ino.elf $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.elf
  1013. else
  1014. echo "$(tput setaf 2)Zip multi language firmware for MK2.5/miniRAMbo board to PF-build-hex folder$(tput sgr 0)"
  1015. cp -f firmware_cz.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-cz.hex
  1016. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-de.hex
  1017. cp -f firmware_es.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-es.hex
  1018. cp -f firmware_fr.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-fr.hex
  1019. cp -f firmware_it.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-it.hex
  1020. cp -f firmware_pl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-pl.hex
  1021. cp -f firmware_nl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-nl.hex
  1022. cp -f $BUILD_PATH/Firmware.ino.elf $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.elf
  1023. if [ $TARGET_OS == "windows" ]; then
  1024. zip a $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  1025. rm $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  1026. elif [ $TARGET_OS == "linux" ]; then
  1027. # Make a copy for MK404 sim of MK2, MK2.5, MK2.5S firmware
  1028. if [ ! -z "$mk404_flag" ]; then
  1029. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  1030. fi
  1031. # End of MK2, MK2.5, MK2.5S firmware copy
  1032. zip -m -j ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  1033. fi
  1034. fi
  1035. # Cleanup after build
  1036. if [[ -z "$clean_flag" || "$clean_flag" == "0" ]]; then
  1037. echo "$(tput setaf 3)"
  1038. ./fw-clean.sh || exit 51
  1039. ./lang-clean.sh || exit 52
  1040. echo "$(tput sgr 0)"
  1041. fi
  1042. else
  1043. echo "$(tput setaf 2)Copying English only firmware to PF-build-hex folder$(tput sgr 0)"
  1044. cp -f $BUILD_PATH/Firmware.ino.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex || exit 47
  1045. echo "$(tput setaf 2)Copying English only elf file to PF-build-hex folder$(tput sgr 0)"
  1046. cp -f $BUILD_PATH/Firmware.ino.elf $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.elf || exit 47
  1047. fi
  1048. # Cleanup Firmware
  1049. if [[ -z "$prusa_flag" || "$prusa_flag" == "0" ]]; then
  1050. rm $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 53
  1051. fi
  1052. # Delete dupblicates
  1053. if find $SCRIPT_PATH/lang/ -name '*RAMBo10a*.txt' -printf 1 -quit | grep -q 1
  1054. then
  1055. rm $SCRIPT_PATH/lang/*RAMBo10a*.txt
  1056. fi
  1057. # MK2 not supported in this branch
  1058. if find $SCRIPT_PATH/lang/ -name '*MK2-RAMBo13a*' -printf 1 -quit | grep -q 1
  1059. then
  1060. rm $SCRIPT_PATH/lang/*MK2-RAMBo13a*.txt
  1061. fi
  1062. if find $SCRIPT_PATH/lang/ -name 'not_tran.txt' -printf 1 -quit | grep -q 1
  1063. then
  1064. rm $SCRIPT_PATH/lang/not_tran.txt
  1065. fi
  1066. if find $SCRIPT_PATH/lang/ -name 'not_used.txt' -printf 1 -quit | grep -q 1
  1067. then
  1068. rm $SCRIPT_PATH/lang/not_used.txt
  1069. fi
  1070. #New fresh PF-Firmware-build
  1071. if [ "$new_build_flag" == "1" ]; then
  1072. rm -r -f $BUILD_PATH/* || exit 54
  1073. fi
  1074. # Restore files to previous state
  1075. sed -i -- "s/^#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/g" $SCRIPT_PATH/Firmware/Configuration.h
  1076. sed -i -- 's/^#define FW_REPOSITORY "Prusa3d"/#define FW_REPOSITORY "Unknown"/g' $SCRIPT_PATH/Firmware/Configuration.h
  1077. if [ ! -z "$BUILD_ORG" ] ; then
  1078. sed -i -- "s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD_ORG/g" $SCRIPT_PATH/Firmware/Configuration.h
  1079. fi
  1080. echo $MULTI_LANGUAGE_CHECK
  1081. #sed -i -- "s/^#define LANG_MODE * /#define LANG_MODE $MULTI_LANGUAGE_CHECK/g" $SCRIPT_PATH/Firmware/config.h
  1082. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  1083. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  1084. if [ $OUTPUT == "1" ] ; then
  1085. sleep 5
  1086. fi
  1087. # Restore build env files to previous state
  1088. sed -i -- "s/^#define FLASHEND .*$/#define FLASHEND 0x3FFFF/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  1089. sed -i -- "s/^prusa_einsy_rambo.upload.maximum_size.*/prusa_einsy_rambo.upload.maximum_size=253952/g" $BUILD_ENV_PATH/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION/boards.txt
  1090. sed -i -- "s/^#define RAMEND.*/#define RAMEND 0x21FF/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  1091. done
  1092. # Switch to hex path and list build files
  1093. cd $SCRIPT_PATH
  1094. echo "$(tput setaf 2) "
  1095. echo " "
  1096. echo "Build done, please use Slic3rPE > 1.41.0 to upload the firmware"
  1097. echo "more information how to flash firmware https://www.prusa3d.com/drivers/ $(tput sgr 0)"
  1098. #### End building
  1099. #### MK404 Simulator
  1100. # Check/compile MK404 sim
  1101. if [ ! -z "$mk404_flag" ]; then
  1102. ./MK404-build.sh -c1 || exit 61
  1103. # For Prusa MK2, MK2.5/S
  1104. if [ "$MOTHERBOARD" == "BOARD_RAMBO_MINI_1_3" ]; then
  1105. MK404_PRINTER="${MK404_PRINTER}_mR13"
  1106. else
  1107. if [[ "$mk404_flag" == "2" || "$mk404_flag" == "MMU2" || "$mk404_flag" == "MMU2S" ]]; then # Check if MMU2 is selected only for MK3/S
  1108. MK404_PRINTER="${MK404_PRINTER}MMU2"
  1109. fi
  1110. fi
  1111. # Run MK404 with 'debugcore' and/or 'bootloader-file'
  1112. echo "MK404_DEBUG --$MK404_DEBUG--"
  1113. if [ "$MK404_DEBUG" == "atmega404" ]; then
  1114. MK404_options="--debugcore"
  1115. elif [ "$MK404_DEBUG" == "atmega404_no_bootloader" ]; then
  1116. MK404_options='--debugcore --bootloader-file ""'
  1117. fi
  1118. # Run MK404 with grafics
  1119. if [ ! -z "$graphics_flag" ]; then
  1120. echo "MK404_options --$MK404_options--"
  1121. if [ ! -z "$MK404_options" ]; then
  1122. MK404_options="${MK404_options} --colour-extrusion --extrusion Quad_HR -g "
  1123. else
  1124. MK404_options="--colour-extrusion --extrusion Quad_HR -g "
  1125. fi
  1126. if [[ "$graphics_flag" == "1" || "$graphics_flag" == "lite" ]]; then
  1127. MK404_options="${MK404_options}lite"
  1128. elif [[ "$graphics_flag" == "2" || "$graphics_flag" == "fancy" ]]; then
  1129. MK404_options="${MK404_options}fancy"
  1130. else
  1131. echo "$(tput setaf 1)Unsupported MK404 graphics option $graphics_flag$(tput sgr 0)"
  1132. fi
  1133. fi
  1134. # Output some useful data
  1135. echo "Printer: $MK404_PRINTER"
  1136. echo "Options: $MK404_options"
  1137. # Change to MK404 build folder
  1138. cd ../MK404/master/build
  1139. # Copy language bin file for MK3 and MK3S to xflash
  1140. # if [ -f $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-lang.bin ]; then
  1141. # echo "Copy 'FW$FW-Build$BUILD-$VARIANT-lang.bin' to 'Prusa_${MK404_PRINTER}_xflash.bin'"
  1142. # dd if=/dev/zero bs=1 count=262145 | tr "\000" "\377" >Prusa_${MK404_PRINTER}_xflash.bin
  1143. # dd if=$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-lang.bin of=Prusa_${MK404_PRINTER}_xflash.bin conv=notrunc
  1144. # fi
  1145. #Decide which hex file to use EN_ONLY or Multi language
  1146. if [ "$LANGUAGES" == "ALL" ]; then
  1147. MK404_firmware_file=$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  1148. else
  1149. MK404_firmware_file=$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex
  1150. fi
  1151. # Start MK404
  1152. # default with serial output and terminal to manipulate it via terminal
  1153. ./MK404 Prusa_$MK404_PRINTER -s --terminal $MK404_options -f $MK404_firmware_file || exit 62
  1154. fi
  1155. #### End of MK404 Simulator